# -*- coding: utf-8 -*-
import sqlite3
import json
from httplib2 import Http
# from urllib import urlencode
import time
from datetime import datetime
from datetime import timedelta
import sys
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities
from hilos import ejecutar_tarea
from hilos import func_no_bloquear
from string import ascii_letters
import argparse
import os.path
import codecs

from selenium.webdriver.firefox.options import Options

"""
 Este modulo usa selenium para levantar una web con whatsapp.
"""
UTF8Writer = codecs.getwriter('utf8')
sys.stdout = UTF8Writer(sys.stdout)
# from selenium.webdriver.chrome.options import Options

# firefox opcion abrir modo privado
o = Options()
o.add_argument('-private')
# firefox opcion abrir modo privado
c = Options()
c.add_argument('--incognito')


# ip de atapis
# host = 'http://127.0.0.1:901' #local
# host = 'http://192.168.0.111:901'  # este es atapi en la pc de paco
# host = 'http://192.168.0.114:901' #elias
# host = 'http://54.221.207.114:901'  # amazon
# host = 'http://192.168.0.67:901'  # 67

def srvatapi():
    ip = None
    # Leer un archivo llamado srvatapi.txt
    try:
        archivo = open('srvatapi.txt', 'r')
        ip = archivo.read()
        # print(len(host))
        # print(type(host))
        archivo.close()
    except Exception as error:
        print("No se encontro una ip valida; TRY LINEA 49", error)

    return ip


host = srvatapi()
print(host)

plataforma = sys.platform


# Esto hace que abra el chrome
# si por alguna razon no funciona lo de abajo, descomentar esto.
# driver = webdriver.Chrome(executable_path="chromedriver")
# Esto hace que geckodriver levante firefox
# driver = webdriver.Firefox(executable_path="/home/elias/Downloads/geckodriver")

def es_windows():
    return plataforma == "win32" or plataforma == "win64"


def es_linux():
    return plataforma == 'linux2'


# Indiferentemente de si corremos el bot en linux o windows, por ahora usara siempre
# Google Chrome.
# Version chromedriver: 86
# Version Chrome: 86

# Archivos que deben estar en la misma carpeta que el exe/script de python

# chromedriver (si se va a ejecutar en windows, debe ser chromedriver.exe)
# srvatapi.txt

# NOTA: al compilar con pyinstaller 2.1, por ahora se deben poner la carpeta de
# selenium y httplib2 en la carpeta dist/wsp

driver = None

if es_windows():
    print("ESTAS En windows papu")
    # Abrir chrome en linux
    driver = webdriver.Chrome('chromedriver.exe')



elif es_linux():
    print("Estas en linux papa")
    # Abrir chrome en linux
    driver = webdriver.Firefox(executable_path='./geckodriver')


# Abrir chrome en linux
# se quito esto porque deberia identificar el sistema operativo en el que esta
# corriendo y levantar el correspondiente driver .
# driver = webdriver.Chrome('chromedriver',
#                           chrome_options=c)

if host is None or len(host) == 0:
    print('No se ingreso una ip de Atapis valida, revisar srvatapi.txt')
    driver.quit()

# caps = webdriver.DesiredCapabilities().FIREFOX
# caps["marionette"] = True
# Abrir firefox en linux
# driver = webdriver.Firefox(executable_path="/home/elias/Downloads/geckodriver",
#                            firefox_options=o)

"""
TELEFONO_CLIENTE var global para guardar el telefono del cliente. 
Ahora la que funciona es 4131313.

estado_sesion var global que guarda el estado de la sesion.  

muylargo . var que se pone en 1 si el mensaje que mando un usuario es muy largo
y que la sqlite no tire error. 
"""
TELEFONO_CLIENTE = ""
estado_sesion = False
verificar_pendientes = True
muylargo = '1'

# abre la web de wsp
driver.get("https://web.whatsapp.com/")
# espera
wait = WebDriverWait(driver, 20)
# cabecera
headers = {'Content-type': 'application/x-www-form-urlencoded'}


def iniciar_app_con_parametro():
    # funcion que obtiene desde las propiedades el numero del cliente
    # Al ejecutar el servicio se le deben pasar los siguientes parámetros
    parser = argparse.ArgumentParser(description='AtMsj')
    # Setear si se va a utilizar la base de datos local "cp2000" o una base
    # de AMAZON especificada por la empresa del cliente
    parser.add_argument(
        '-phone',
        help='Número de teléfono del cliente',
        required=True
    )

    # Guardo los parámetros recibidos
    args = []
    args.extend(sys.argv)
    args.pop(0)
    args = parser.parse_args(args)

    phone = args.phone

    global TELEFONO_CLIENTE

    TELEFONO_CLIENTE = phone


"""
    Whatsapp tiene la peculiaridad de cambiarle los nombres a las clases a cada
    x tiempo. por lo que creo estas variables para que en el momento en el que
    cambien, identificarlas y ponerlas aca.
"""
global varifica_si_ventana_abierta
# varifica que haya una ventana seleccionada y no este en el mensaje 'manten tu
# telefono conectado... whatsapp se conecta a tu telefono.... ', si esta
# esa ventana, entonces quiere decir, que no se hizo click en ningun numero.
# varifica_si_ventana_abierta = "//canvas[@role='img']"
# varifica_si_ventana_abierta = "//div[@id='main']"
varifica_si_ventana_abierta = "//div[@data-asset-intro-image-light='true']"

# esta clase obtiene el numero de la ventana abierta desde el titulo
# arriba de todo (en la parte donde estan las opciones, buscar, adjuntar.)
numero_persona_ventana_abierta = '//*[@id="main"]/header/div[2]/div[1]'

# esta clase obtiene los mensajes recibidos
mensajes_recibidos_in = 'message-in'

# esta obtiene los tipo texto
mensaje_tipo_texto = "copyable-text"
texto_seleccionable = "selectable-text"

# esta optiene el atributo de este texto (es decir, fecha y hora) en este campo
# en el campo data pre plait text, se guarda la fecha y la hora.
atributos_pre_texto_plano = 'data-pre-plain-text'

# Este selector obtiene el div de la persona para mandar un mensaje
# despues de buscarla
# CSS SELECTOR
persona_encontrada = '//*[@id="pane-side"]/div/div/div/div/div/div/div[2]/div[2]/div[1]/span/span'
# Esto busca el elemento que contiene a la persona seleccionada, SOLO PARA WPP BUSINESS
persona_encontrada_business = 'div._1C6Zl:nth-child(2)'
# Este selector obtiene el div donde se escriben los mensajes para enviar
# XPATH SELECTOR
selector_enviar_mensaje = '//*[@id="main"]/footer/div[1]/div[2]/div/div[2]'


# Esta obtiene el atributo de texto que contiene la fecha y la hora en los mapas
# XPATH
fecha_hora_mapa = '//div[@data-plain-text]/..'

# y en esta clase "data-plain-text", se guarda , el texto plano. si es el mapa.
# guarda el link.
atributos_textos_planos = "data-plain-text"

# clase que obtiene el mapa
clase_obtiene_mapa = 'div[data-plain-text]'

# clase para el estado de la sesion (obtiene la clase donde esta el QR)
estado_sesion_qr = "_26GJk"

# clase que encuentra audios
clase_audio = "_1lxsr"

# pane-side > div > div > div > div:nth-child(2) selector
# //*[@id="pane-side"]/div/div/div/div[2] xpath
# obtiene los contactos. no se muy
obtener_todos_los_contactos_cargados = '//*[@id="pane-side"]/div/div/div/div'

# verifica la clase de pendientes, es decir, si aparece el numero en verde,
# es que es un mensaje pendiente.
cantidad_de_mensaje_msj_pendiente = "VOr2j"

# mensaje obtenido a la izquierda.
mensaje_rapido_obtenido = "_2iq-U"

# obtiene el numero de la persona, de la izquierda, es decir, el pendiente.
# //*[@id="pane-side"]/div/div/div/div[18]/div/div/div[2]/div[1]/div[1]/span
numero_pendiente_persona_izquierda = "VOr2j"

# nombre de icono de la bateria baja (todavia no lo estoy usando)
alert_batter = "alert-battery"

# input_de_persona_para_enviar_msg
input_de_persona_para_enviar_msg = '//*[@id="side"]/div[1]/div/label/div/div[2]'

clase_flecha_abajo = '_2-aNW'

# Esto se usa para que no almacene datos en la cache ya que si se borra la db
# sigue obteniendo datos que no estan en el archivo, sino en la memoria.
archivo_basedatos = "basededatos.db"
# verifica que exista el archivo, si no existe, lo crea.
if not os.path.isfile(archivo_basedatos):
    # crea la base de datos si no existe
    try:
        # creo la conexion al archivo.
        conn = sqlite3.connect(archivo_basedatos)
        # pongo en variable c
        c = conn.cursor()
        # creo la tabla
        c.execute(""" CREATE table mensajes (
            fecha_hora text,
            mensaje text,
            estado text,
            fecha_hora_actual text,  
            numero text,
            muylargo text    
        )""")
        # # ejecuto
        conn.commit()
        # # cierro la conexion -decidi no cerrarla porque la necesito despues -
        # conn.close()

    # si no se pudo crear la db
    except Exception as erroR:
        print("Error al abrir la base de datos", erroR)
else:
    conn = sqlite3.connect(archivo_basedatos)
    # pongo en variable c
    c = conn.cursor()


def conectar():
    "Esto esta por si borran la db mientras el programa esta corriendo"
    cache_size = 0
    if not os.path.isfile(archivo_basedatos):
        # crea la base de datos si no existe
        try:
            # db = TinyDB('basededatos.json')
            # conn = sqlite3.connect("basededatos.db")
            # creo la conexion al archivo.
            conn = sqlite3.connect(archivo_basedatos)

            conn.row_factory = sqlite3.Row
            # pongo en variable c
            c = conn.cursor()
            # creo la tabla
            c.execute(""" CREATE table mensajes (
                fecha_hora text,
                mensaje text,
                estado text,
                fecha_hora_actual text,  
                numero text,
                muylargo text        
            )""")
            conn.close()
        except Exception as error:
            # si no encuentra el copyable text, que siga.
            print("Error al crear o leer la base de datos", error)


clase_bateria = "//span[@data-icon='down']"


#####obtengo la fecha y hora, se puede poner en una funcion.##
# fecha_hora
def obtener_hora_mensaje(elemento_con_hora):
    sin_inicial = elemento_con_hora.get_attribute(
        atributos_pre_texto_plano).replace('[', '')
    sin_nada = sin_inicial.replace(']', '')
    fecha = sin_nada[:-21]
    return fecha


def verificar_ventana_abierta(cantidad_mensajes=20):
    """
    Esta funcion verifica los mensajes recibidos al hacer click en un usuario
    si tiene mensajes nuevos, los guarda, sino, no hace nada.
    :return:
    """
    # Se pone a modo de prueba la cantidad de mensajes
    # cantidad_mensajes = 20
    try:
        # Clase de la flecha para abajo cuando subimos a ver los msgs anteriores
        if (driver.find_elements_by_class_name(clase_flecha_abajo)):
            # busca si está la alerta de la batería no se para que
            elem = driver.find_element_by_xpath(clase_bateria)
            elem.click()
    except:
        # print("no pude bajar a ver los demas mensajes.")
        pass

    try:
        if (driver.find_elements_by_xpath(varifica_si_ventana_abierta)):
            # if (driver.find_element_by_xpath(varifica_si_ventana_abierta)):
            print("No hay ventana seleccionada")
            pass
        else:
            try:

                # obtengo el nro de la persona desde la parte superior
                numero_persona \
                    = driver.find_element_by_xpath(numero_persona_ventana_abierta)

                numero_persona = numero_persona.text

                try:  # Inicio un try para verificar si el telefono_origen es un numero(no esta agendado)

                    telefono = numero_persona[1:]  # Guardo el telefono sin el '+'

                    telefono = telefono.replace('-', '')  # Borro los guiones del telefono

                    int(telefono)  # Intento convertirlo en un numero

                    telefono = '+' + telefono  # Si llego hasta aca es porque es un numero de telefono

                    numero_persona = telefono

                except:

                    numero_persona = numero_persona  # Si no es un telefono, lo guardo como lo recibi


            except Exception as erro:
                print("ERROR, No pude obtener el nombre de la persona", erro)
                pass

        mensajes_recibidos_por_cliente = []
        mensajes_enviados = 0

        print("LARGO: ", len(driver.find_elements_by_class_name(mensajes_recibidos_in)[-1:]))

        # obtengo todos los mensajes recibidos
        for mensaje_in in driver.find_elements_by_class_name(
                mensajes_recibidos_in)[-1:]:
            try:
                dic = {}

                # Verifico si el mensaje es un mapa
                # Si no es un mapa va a devolver una lista vacia y el if sera False
                if mensaje_in.find_elements_by_css_selector(
                        clase_obtiene_mapa):

                    # Creo la ariable mapa y la almaceno buscando un:
                    # div con atributo data-plain-selector
                    mapa = mensaje_in.find_element_by_css_selector(
                        clase_obtiene_mapa)

                    # Almacena el link del mapa en el diccionario como:
                    # dic['mensaje'] = link
                    dic['mensaje'] = mapa.get_attribute('data-plain-text')

                    # Almaceno la hora del mensaje como:
                    # dic['fecha_hora'] = funcion para obtener hora del mensaje
                    dic['fecha_hora'] = obtener_hora_mensaje(
                        mensaje_in.find_element_by_xpath(
                            fecha_hora_mapa))
                    print("DICCIONARIO MAPA: ", dic)

                    # Agrego el mensaje con su fecha,hora y texto a la lista
                    mensajes_recibidos_por_cliente.append(dic)

                else:

                    # Busca mensajes de texto en el chat

                    # Esta variable contiene el div superior al que contiene lo que dice el mensaje
                    arriba_msj_texto = mensaje_in.find_element_by_class_name(
                        mensaje_tipo_texto)

                    # Esta variable contiene el texto real del mensaje.
                    msj_texto = arriba_msj_texto.find_element_by_class_name(
                        "selectable-text")

                    # Guardo el mensaje en el diccionario
                    dic['mensaje'] = msj_texto.text

                    # Guardo la hora y fecha en el diccionario
                    dic['fecha_hora'] = obtener_hora_mensaje(arriba_msj_texto)

                    # Agrego el mensaje con su fecha,hora y texto a la lista
                    mensajes_recibidos_por_cliente.append(dic)

                    # print(mensajes_recibidos_por_cliente)
            except Exception as error:
                # si no encuentra el copyable text, que siga.
                # print("ERR0R", error)
                # print(dic, error)
                continue

        # print ("dic e.text", "la s", mensajes_recibidos_por_cliente)
        # print(mensajes_recibidos_por_cliente)
        mensajes_enviados = 0

        # guardar los mensajes recibidos
        for i in mensajes_recibidos_por_cliente[-cantidad_mensajes:]:
            # print "i", i
            # Guardo en mi DB el mensaje obtenido
            # time.sleep(0.02)

            nombre_dato = i['fecha_hora'].strip().replace(',', '')

            # llamo a la funcion que verifica si es un elemento fecha
            # 17/2/20
            # rta_dato = ver_si_dato_es_ano(nombre_dato)

            mensajes_enviados = crear_db_local(numero_persona, 'nuevo'
                                               , i['mensaje'], i['fecha_hora'])

        if mensajes_enviados != 0 or mensajes_enviados == None:
            return verificar_ventana_abierta()
        else:
            global verificar_pendientes
            verificar_pendientes = True

        return True

    except Exception as erro:
        """
        # si el error es: Message: chrome not reachable
        Es porque el selenium está corriendo pero el navegador se cerro.
        tiene que cerrar selenium y volver a abrirlo.
        """
        # print ("no pude detectar ventana abierta", erro)

        return False


################################################################################
# no se usa
def buscar_audios():
    for mensaje_in in driver.find_elements_by_class_name(mensajes_recibidos_in):
        audio = mensaje_in.find_element_by_class_name(clase_audio)

        #
        if audio != "":
            # print "Te llego un audio, ", audio.text
            e = mensaje_in.find_element_by_class_name(mensaje_tipo_texto)

            s = mensaje_in.find_element_by_class_name("selectable-text")
            # print "Clickeado ", audio.click()

            # print "el ese ", audio


###############################################################################

def verificar_version():
    try:
        driver.find_element_by_css_selector(persona_encontrada_business)
        print('Utilizando WhatsApp Business')
        return driver.find_element_by_css_selector(persona_encontrada_business)
    except:
        print('Utilizando WhatsApp Normal')
        return driver.find_element_by_xpath(persona_encontrada)

def es_numero_agendado(nombre):
    '''
    Esta funcion se encarga de verificar si un nombre es un numero de telefono o esta agendado bajo otro nombre.

    :param nombre: (str) Un numero de telefono en WhatsApp, agendado o no.
    :return: (bool)
    '''

    try:  # Inicio un try para verificar si el telefono_origen es un numero(no esta agendado)

        telefono = nombre[1:]  # Guardo el telefono sin el '+'

        int(telefono)  # Intento convertirlo en un numero

        telefono = '+' + telefono  # Si llego hasta aca es porque es un numero de telefono

        telefono = telefono[:3] + " " + telefono[3] + " " + telefono[4:8] + " " + telefono[8:10] + "-" + telefono[10:]

        return telefono

    except:

        return nombre


def enviar_msg(name, mensaje=None):
    '''
    Recibe un nombre, con el cual buscar en el buscador de personas de whatsapp,
    una vez localizado se le enviara el mensaje al usuario

                Parámetros:
                name (str)
                mensaje (str)

            Funciones:
                at.utiles.hilos -> respuesta

    '''

    if mensaje == "\n" or mensaje == "":
        return

    try:
        # Tomo el elemento para buscar un chat.
        buscador = driver.find_element_by_xpath('//div[@contenteditable]')

        # Hago click en el buscador.
        buscador.click()

        # Limpio el buscador
        buscador.clear()

        print("NOMBRE PERSONA ENVIAR: ", name)

        # Escribo el numero/nombre a quien quiero enviar mensaje
        buscador.send_keys(name)

        # Primero verificamos si tenemos agendada a la persona y cambiaremos el nombre en base a esto
        nombre = es_numero_agendado(name)

        persona = driver.find_element_by_xpath('//span[contains(text(), ' + "'" + nombre + "'" + ')]')
        
        persona.click()

        # Ahora busco la caja para escribir mensajes
        input_mensajes = driver.find_element_by_xpath(selector_enviar_mensaje)

        # Le hago click
        input_mensajes.click()

        # Espero 3 segundos (cambiar por numero random)
        # time.sleep(3)
        print("MENSAJE: ", mensaje.split('\n'))

        msj_separado = mensaje.split('\n')

        nuevo_msj = ""

        for linea in msj_separado:

            # Escribo el mensaje
            input_mensajes.send_keys(linea)

            input_mensajes.send_keys(Keys.LEFT_ALT, Keys.ENTER)

        input_mensajes.send_keys(Keys.ENTER)

        # Cerramos el envio de mensajes
        cruz = driver.find_element_by_css_selector('._3Eocp > span:nth-child(1)')

        time.sleep(3)

        cruz.click

    except Exception as error:
        print('Error al intentar mandar un mensaje.', error)

        cruz = driver.find_elements_by_css_selector('._3Eocp > span:nth-child(1)')

        if len(cruz) == 0:
            return

        cruz.click()



            # try:
            #     try:
            #         limpiar = driver.find_element_by_xpath \
            #             ("//div[@data-tab='3']")
            #         limpiar.click()
            #         time.sleep(1)
            #         limpiar.clear()
            #         limpiar.send_keys("")
            #     except Exception as error:
            #         print("No pude limpiar")
            #     try:
            #         # Busco el path del buscador de personas
            #         elem = driver.find_element_by_xpath \
            #             (input_de_persona_para_enviar_msg)
            #         elem.clear()
            #         elem.send_keys("")
            #         # Hago click ahi
            #         elem.click()
            #
            #         # Pongo el nombre que se recibio
            #         print("pongo el nombre q recibo", name)
            #         # elem.clear()
            #         elem.send_keys(name)
            #         # Espero 3 (tres) segundos
            #         time.sleep(3)
            #         # Hago clic en el nombre encontrado
            #         driver.find_element_by_xpath("//*[@title='" + name + "']").click()
            #         print("No pude hacer click en la persona obtenida")
            #         # Espero 3 (tres) segundos
            #         time.sleep(0.2)
            #     except:
            #         print("No encontre la persona")
            #         pass
            #         # print "No pude encontrar a la persona"
            #     elem = driver.find_element_by_xpath("//div[@data-tab='1']")
            #     # Busco el campo de texto para escribir
            #     # elem = driver.find_element_by_xpath("//span[@dir='auto']")
            #     # Hago clic ahi
            #     elem.click()
            #     elem.clear()
            #     # Envio el mensaje con enter
            #     elem.send_keys(mensaje + Keys.ENTER)
            #     # Espero 3 segundos
            #     time.sleep(0.3)
            #     elem = driver.find_element_by_xpath \
            #         (input_de_persona_para_enviar_msg)
            #     # "//input[@title='Buscar o empezar un chat nuevo']")
            #     # elem.clear()
            #     elem.send_keys("")
            # # Si no pude encontrar el buscador de personas
            # except Exception as erro:
            #     # Limpio , ponele
            #
            #     elem = driver.find_element_by_xpath(
            #         "//*[@id='side']/div[1]/div/label/div")
            #     # elem = driver.find_element_by_xpath(
            #     #         "//*[@id='side']/div[1]/div/label/div")
            #     # Dejo el campo vacio
            #     elem.clear()
            #     elem.send_keys("")
            #     elem = driver.find_element_by_xpath(
            #         "//div[@tabindex='-1']//div[@data-tab='1']")
            #     elem.click()
            #     elem.clear()
            #     # y aviso que no pude enviar el msg
            #     print("No pude enviar el mensaje", erro)


################################################################################

# def nuevo_servicio(name):
#     # creo que no se usara mas
#     try:
#         elem = driver.find_element_by_xpath(
#             "//input[@title='Buscar o empezar un chat nuevo']")
#         elem.click()
#         elem.send_keys(name)
#         time.sleep(5)
#         driver.find_element_by_xpath("//*[@title='" + name + "']").click()
#         time.sleep(5)
#         elem = driver.find_element_by_xpath("//div[@data-tab='1']")
#         elem.click()
#         # Envio los textos y presiono shift + enter para que no mande el mensaje
#         elem.send_keys("****** **Nuevo servicio:** ******" + Keys.SHIFT + Keys.ENTER)
#         elem.send_keys("**Para cargar un servicio ingrese primero la calle** " + Keys.SHIFT + Keys.ENTER)
#         elem.send_keys("**Ejemplo**: Pueyrredon" + Keys.SHIFT + Keys.ENTER)
#         elem.send_keys("**Luego ingrese la altura**" + Keys.SHIFT + Keys.ENTER)
#         elem.send_keys("**Ejemplo**: 382" + Keys.SHIFT + Keys.ENTER)
#         # Aca envio el menu (presionando solo enter)
#         elem.send_keys("****** **Nuevo servicio:** ******" + Keys.ENTER)
#
#         time.sleep(5)
#     except Exception as erro:
#         # print "Error", erro
#         pass


#######################################################

def revisar_mensajes_pendientes():
    '''
    revisa del menu lateral los que tienen iconitos verdes
    Esta funcion se encarga de revisar si hay mensajes sin leer, si es asi,
    llama a la funcion obtener mensajes pendientes, para que esta
    se encargue del resto. (enviar msgs, marcarlos como pendientes, leidos, etc.
    :return:
    '''

    # Obtengo todos los chats cargados
    chats = driver.find_elements_by_xpath(obtener_todos_los_contactos_cargados)

    if len(chats) == 0:  # Si no hay chats abiertos
        print("No hay chats abiertos")
        return

    time.sleep(5)  # Espero 5 segundos

    for chat in chats:  # Itero a traves de los chats abiertos

        # try por si no puede obtener msg pendientes
        try:

            # Intentamos obtener el elemento con el iconito verde
            mensajes_pendientes = chat.find_elements_by_class_name(cantidad_de_mensaje_msj_pendiente)

            if len(mensajes_pendientes) == 0:  # Si no encontramos ningun iconito verde
                # Continuamos con el loop
                continue

            # Si lo encontre lo almaceno en la variable
            mensajes_pendientes = mensajes_pendientes[0]

            # Le hago click al iconito para entrar al chat
            mensajes_pendientes.click()

            rta = verificar_ventana_abierta(5)  # Llamo a la funcion para leer los mensajes de la ventana abierta
            print("VERIFICAR VTANA ABIERTA: ", rta)
        except Exception as error:  # Si fallamos en algun momento
            # Printeamos el error
            print("Exception de revisar mensajes: ", error)

            continue  # Continuamos con el loop


#######################################################

def verificar_estado_de_la_sesion():
    '''
    Esta funcion verifica que no se haya cerrado la sesion verificando
    Lo que hace es verificar si encuentra el QR, si es asi, deduzco que
    la sesion se cerro, y deberia avisar al servidor. Sino, no hago nada.
    :return:
    '''

    global estado_sesion

    # print("estado_sesion", estado_sesion)
    # Me que si existe la siguiente clase, no me salte error
    try:
        # Busco la clase que aparece cuando esta la sesion cerrada
        if (driver.find_element_by_class_name(estado_sesion_qr)):
            estado_sesion = False
            # Le aviso al servidor que esta la sesion cerrada
            print("Error, La sesion esta cerrada", estado_sesion)
            # Si la sesion esta abierta, no hago nada
    except:
        # No hago nada
        estado_sesion = True
        # print("Sesion iniciada", estado_sesion)


#######################################################

# No se usa # No se usa# No se usa# No se usa# No se usa# No se usa
# def obtener_y_responder_mensajes_pendientes():
#     '''
#     Esta funcion verifica los mensajes pendientes de los clientes, si encuentra
#     alguno, le envia el mensaje al servidor y guarda en base de datos local que el
#     mensaje se envio y quedo pendiente. Cuando el servidor me avise que ya lo tiene,
#     marco este mensaje como leído.
#     :return:
#     '''
#
#     # revisa todos los contactos
#     for aa in driver.find_elements_by_class_name('X7YrQ'):
#         # print(dir(aa))
#
#         # try por si no puede obtener msg pendientes
#         try:
#             # si existe algun mensasje pendiente
#             if (aa.find_element_by_class_name('P6z4j')):
#                 # guarda el numero
#                 mensaje = aa.find_element_by_class_name('_1Wn_k').text
#
#             # try por si no puede obtener elnombre
#             try:
#                 # obtiene el nombre
#                 if (aa.find_element_by_class_name('_3NWy8')):
#                     # guarda el nombre obtenido
#                     nombre = aa.find_element_by_class_name('_3NWy8').text
#                     # muestra
#                     # print('Nombre:', nombre)
#                     # print('Mensaje:', mensaje)
#                     # Si me envia hola, le doy pelota y le muestro el menu
#                     # if (mensaje == "hola"):
#                     # print ("Recibiste el mensaje hola ")
#                     # Si recibo cualquier mensaje, le envío el menú
#                     # while mensaje !='nuevo':
#                     # if(mensaje!="nuevo"):
#                     # enviar_msg(nombre)
#                     #
#                     #     #primer parametro nro del cliente.
#                     #     rta_nuevo_msj = nuevo_msj('3413539428', nombre, mensaje,
#                     #                               nombre)
#                     #     print('*** rta_nuevo_msj')
#                     #     print(rta_nuevo_msj)
#                     #     print(type(rta_nuevo_msj))
#
#                     # Si me recibo 'nuevo servicio' entonces le aviso al server
#                     if (mensaje == "Nuevo servicio" or mensaje == "nuevo servicio" or
#                             mensaje == "nuevo" or mensaje == "Nuevo" or mensaje == "1"):
#                         print("Cargar nuevo servicio")
#                         # Carga nuevo servicio
#                         nuevo_servicio(nombre)
#
#             # si no pudo obtener el nombre
#             except:
#                 # muestra print de error
#                 print("No se pudo obtener el nombre")
#         # si no pudo obtener msg pendientes, prueba con el siguiente
#         except Exception as error:
#             print("hubo un error ", error)
#             continue
#

#######################################################

# nuevo mensaje recibido

def nuevo_msj_recibido(telefono_origen, telefono_destino, mensaje, nombre,
                       hora_mensaje):
    """
    funcion para el envio de un mensaje del usuario al servidor

    'Si se recibe el error: No se pudieron obtener los par\xe1metros del
    tel\xe9fono +54 9 3413 19-9175. Hay que revisar la tabla telefonos_api
    y poner la ip de donde está atmsj.

    Tambien verificar que -phone nro_empresa este puesto.'

    :param telefono_origen:
    :param telefono_destino:
    :param mensaje:
    :param nombre:
    :return:
    """

    funcion = '/nuevo_mensaje'
    print(mensaje)
    http = Http(disable_ssl_certificate_validation=True)

    # print(telefono_origen, telefono_destino, mensaje, nombre,
    #                    hora_mensaje)

    # NOTA:
    # Con el dato tel_cliente se podría buscar a que cliente le pertenece
    # el teléfono y que producto usa

    url = host + funcion

    dic = {}
    # numero del usuario
    dic['telefono_origen'] = telefono_origen
    # numero del cliente
    dic['telefono_destino'] = TELEFONO_CLIENTE
    # mensaje del usuario
    dic['mensaje'] = mensaje

    if mensaje[:28] == 'https://maps.google.com/maps':  # Si el mensaje es una ubicacion
        dic['clase'] = 'mapa'  # Seteamos la clase como 'mapa'

    else:
        dic['clase'] = 'txt'  # Sino, seteamos la clase como 'txt'

    # nombre del usuario
    dic['nombre'] = ""
    dic['hora_mensaje'] = hora_mensaje
    print("DICCIONARIO MENSAJE:", dic)
    # '15:25, 11/2'

    # print ("El mensaje nvo msg servidor", mensaje, telefono_origen,
    # telefono_destino, hora_mensaje)

    # Si manda varios mensajes vacios no se van a enviar hasta que no cambie
    # la hora del mensaje, ya que se guarda en la db con otro horario
    if mensaje == "":
        # print "Recibiste un msg en blanco", mensaje

        # enviar_msg(telefono_origen,
        # "**Solo se reciben mensajes de texto o ubicacion**")
        return

    parametros = json.dumps(dic)
    time.sleep(0.3)

    try:
        # hago la reques
        resp, content = http.request(
            url, "POST", headers=headers, body=parametros
        )

    except Exception as erroR:
        dic = {'Estado': False, 'Respuesta': 'No se pudo enviar el mensaje'
                                             'al servidor.'}
        print('falla en el envio del mensaje al server:', erroR)
        return dic
    else:
        print("mensaje enviado ok:", dic)

    # resp, content = http.request(
    #     url, "POST", headers=headers, body=parametros
    # )

    # obtengo la rta
    # para python 2.7
    # rta = json.loads(content)
    # para python 3.*
    rta = json.loads(content.decode('utf-8'))

    # print ("-*-*/-*/--/*/-*/-/")
    # print (rta)

    if rta['Estado'] is True:
        time.sleep(0.2)
        marcar_mensaje_como_leido(telefono_origen, mensaje)
        actualizar_fecha_actual(mensaje, telefono_origen)
        return rta

    if rta['Estado'] is False:
        print(rta['Respuesta'], '-*-*-*-*-')
        # marcar_mensaje_como_leido(telefono_origen)
        return rta

    return rta


########Obtengo los mensajes para enviar###############


#######################################################
# NO SE usa porque ya lo hace el servidor. pero esta linda.

# def obtener_direcciones_posibles():
#     """
#     Obtiene los mensajes que hay que enviar al usuario
#
#     :param tel_cliente:
#     :return:
#     """
#
#     # que funcion voy a llamar
#     funcion = '/obtener_direcciones_posibles'
#
#     # se desactivan los certificados
#     http = Http(disable_ssl_certificate_validation=True)
#
#     # NOTA:
#     # Enviar telefono del cliente, nos retornará los mensajes a enviar
#
#     # se arma la url
#     url = host + funcion
#
#     # se arma el diccionario que voy a enviar
#     dic = {}
#
#     dic['id_api'] = 1
#     dic['id_ciudad'] = 1
#     dic['id_cliente'] = "1_3"
#     dic['msj'] = 'Urquiza+7000'
#
#     # convierto en json el diccionario
#     parametros = json.dumps(dic)
#
#     try:
#
#         # hago la reques
#         resp, content = http.request(
#             url, "POST", headers=headers, body=parametros
#         )
#     except Exception as erroR:
#         print(erroR)
#         return
#
#     rta = json.loads(content.decode('utf-8'))
#
#     print("0000--- obtener_direcciones_posibles", rta)
#
#     if rta['Estado'] is False:
#         print(rta['Respuesta'])
#         return rta['Estado']
#
#     # retorno la rta
#     return rta


def obtener_msj_para_enviar(tel_cliente):
    """
    Obtiene los mensajes desde el server que hay que enviar AL usuario

    :param tel_cliente:
    :return:
    """

    print("pidiendo mensajes al server")

    # que funcion voy a llamar
    funcion = '/msj/obtener_msj_para_enviar'

    # se desactivan los certificados
    http = Http(disable_ssl_certificate_validation=True)

    # NOTA:
    # Enviar telefono del cliente, nos retornará los mensajes a enviar

    # se arma la url
    url = host + funcion

    # se arma el diccionario que voy a enviar
    dic = {}

    dic['telefono'] = TELEFONO_CLIENTE

    # convierto en json el diccionario
    parametros = json.dumps(dic)

    try:
        resp, content = http.request(
            url, "POST", headers=headers, body=parametros
        )
    except Exception as erroR:
        print('error al obtener msj para enviar:', erroR)
        return

    # obtengo la rta
    # para python 2.7
    # rta = json.loads(content)
    # para python 3.*
    rta = json.loads(content.decode('utf-8'))

    if rta['Estado'] is False:
        # print rta['Respuesta']
        return rta['Estado']

    for items in rta['Dato']:
        time.sleep(0.2)
        enviar_msg(items['telefono_destino'], items['mensaje'])
        # print "numero", items['telefono_destino'], "mensaje", items['mensaje']

    print("rta obtener_msj_para_enviar")
    # print (rta)

    # retorno la rta
    return rta


######################################################

def listar_mensajes_no_leidos():
    # creo la conexion al archivo.
    # conn = sqlite3.connect("basededatos.db")
    # # pongo en variable c
    # c = conn.cursor()
    try:
        # acceder a los elementos con los nombres de los cambios de la tabla
        # en vez de usar los indices
        c.row_factory = sqlite3.Row
        query = c.execute("SELECT  * FROM mensajes Where estado != 'leido'")

        resultados = query.fetchall()

        # print("no leidos", resultados)

        # Si no encuentra resultados, es que ya estan todos leidos.
        if resultados == '':
            dato_string_a_convertir = \
                json.dumps([dict(ix) for ix in resultados])

            dato_json_convertido = json.loads(dato_string_a_convertir)
            return dato_json_convertido
        else:
            dato_string_a_convertir = \
                json.dumps([dict(ix) for ix in resultados])

            dato_json_convertido = json.loads(dato_string_a_convertir)
            return dato_json_convertido

    except Exception as error:
        print("Error en listar mensajes no leidos", error)

        # return rta
    # lista_mensajes.sort(key=lambda x: x['fecha_hora'])
    return dato_json_convertido


###############################################################################

def verifica_msjs_leidos_para_limpiar():
    """
    Verifica si todos los msgs de la db estan leidos , y borra la db.
    Cambiarlo para que funcione con sqlite. Esta con dbj.
    :return:
    """
    print("---verificia_msjs_leidos_para_limpiar---")
    archivo = "basededatos.json"
    try:
        db = dbj(archivo)
    except:
        print("listar_mensajes_no_leidos")
        print("Error al abrir la base de datos")

        return []

    rta = db.getall()

    # query = 'estado == "leido"'
    # lista_mensajes = db.find(
    #     query
    # )
    # rta = db.getmany(lista_mensajes)
    try:
        if (rta[0]['estado'] == 'leido'):
            print("limpia todo")
            rt = db.clear()
            os.remove('basededatos.json')
            print(rt)
    except Exception as error:
        print("Table delete", error)

        # return rta


##########################################################################

def pasar_msj_a_pendiente(mensaje, fecha_hora_actual, numero):
    """Esta funcion se encarga de pasar los mensajes nuevos, a pendientes si
    no se envian despues de un tiempo.
    """
    # print("^^^^^ se recibio", mensaje, numero, "para pasar como pendiente")

    try:
        # acceder a los elementos con los nombres de los cambios de la tabla
        # en vez de usar los indices
        c.row_factory = sqlite3.Row
        query = c.execute("SELECT  * FROM mensajes Where "
                          "mensaje=:mensaje and numero=:numero",
                          {'mensaje': mensaje, 'numero': numero})

        resultados = query.fetchall()

        # print("resultado", resultados)

        # si no encuentro resultado, no hago paso nada a pendiente.
        if resultados != "":
            # hago el update del mensaje y numeros recibidos.
            c.execute("UPDATE mensajes SET estado=='pendiente' "
                      "Where "
                      "mensaje=?"
                      "and numero=?",
                      (mensaje, numero))
            conn.commit()

    except Exception as error:
        print("Error en listar mensajes no leidos", error)
        dic = {}
        dic['Estado'] = False
        dic['Respuesta'] = "No se pudo pasar el estado de %s a pendiente." \
                           % numero
        return dic


def actualizar_fecha_actual(mensaje, numero):
    # print("que onda actualizar_fecha_actual", mensaje, numero)

    fecha_hora_actual = obtener_fecha_actual()

    try:
        datetime_to_str = fecha_hora_actual.strftime('%Y-%m-%d %H:%M:%S')
        print(fecha_hora_actual, datetime_to_str)

        # acceder a los elementos con los nombres de los cambios de la tabla
        # en vez de usar los indices
        c.row_factory = sqlite3.Row
        query = c.execute("SELECT  * FROM mensajes Where "
                          "mensaje=:mensaje and numero=:numero",
                          {'mensaje': mensaje, 'numero': numero})

        resultados = query.fetchall()

        # print("resultado", resultados)

        # si no encuentro resultado, no hago paso nada a pendiente.
        if resultados != "":
            # hago el update del mensaje y numeros recibidos.
            c.execute("UPDATE mensajes SET fecha_hora_actual=? "
                      "Where "
                      "mensaje=?"
                      "and numero=?",
                      (datetime_to_str,
                       mensaje, numero))
            conn.commit()

    except Exception as error:
        print("Error en listar mensajes no leidos", error)
        dic = {}
        dic['Estado'] = False
        dic['Respuesta'] = "No se pudo pasar el estado de %s a pendiente." \
                           % numero
        return dic

        # print ("!!!!mensaje", mensaje)
        # print ("!!!!Fecha hora actual ", fecha_hora_actual)
        # print ("!!!!numero", numero)
        # print ("!!!!Es de tipo mensaje ", type(mensaje))
        # print ("!!!!Es fecha de tipo ", type(fecha_hora_actual))
        # print ("!!!!Es de tipo numero", type(numero))


def obtener_fecha_actual():
    return datetime.now()


######### VER pendientes#################
def reenviar_mjes_pendientes():
    """
    Esta funcion se encarga de reenviar los mensajes que quedaron pendientes de
    envio.
    Buscara en la db local si el estado es pendiente y lo mandara al
    servidor. Si este no responde los mantendra.
    :return:
    """
    lista_mensajes = listar_mensajes_no_leidos()
    # print("lista_mensajes", lista_mensajes)

    fecha_hora_actual = datetime.now()

    for elementos in lista_mensajes:

        estado_obtenido_db = elementos['estado']
        # print(elementos['estado'], elementos['numero'], elementos['mensaje'])
        # str_to_datetime = datetime.strptime(elementos['fecha_hora'],
        #                                     '%H:%M %d-%m-%Y')
        nombre_dato = elementos['fecha_hora'].strip().replace(',', '')

        if estado_obtenido_db == "nuevo":
            # str_to_datetime = datetime.strptime(nombre_dato,
            #                                     '%H:%M %d-%m-%Y')
            nombre_dato = elementos['fecha_hora'].strip().replace(',', '')

            # str_to_datetime = datetime.strptime(nombre_dato,'%H:%M:%S %d-%m-%Y')
            #
            # print("str_to_datetime"
            #       ,
            #       str_to_datetime,nombre_dato)
            rta_enviar_msg = nuevo_msj_recibido(str(elementos['numero']),
                                                telefono_destino=TELEFONO_CLIENTE,
                                                mensaje=elementos['mensaje'],
                                                nombre='usuario',
                                                hora_mensaje=elementos[
                                                    'fecha_hora'])

            # print ("$$$ RESPUESTA DEL Nuev msj...", rta_enviar_msg)

            if rta_enviar_msg['Estado'] is False:
                pasar_msj_a_pendiente(elementos['mensaje'],
                                      elementos['fecha_hora_actual'],
                                      elementos['numero'])
                print("$$$Se pasa a pendiente")

            continue

        # print(elementos['fecha_hora_actual'][0:19],"elementos['fecha_hora_actual']")

        str_to_datetime = datetime.strptime(elementos['fecha_hora_actual'],
                                            '%Y-%m-%d %H:%M:%S')

        # print ("El envio del dato se hace por reenvio", str_to_datetime, \
        #     fecha_hora_actual, 'fecha_hora_actual')

        if str_to_datetime < fecha_hora_actual - timedelta(seconds=13):

            rta_nuevo_msj = nuevo_msj_recibido(str(elementos['numero']),
                                               telefono_destino=TELEFONO_CLIENTE,
                                               mensaje=elementos['mensaje'],
                                               nombre='usuario',
                                               hora_mensaje=elementos[
                                                   'fecha_hora'])

            # datetime_to_str = fecha_hora_actual.strftime('%d-%m-%Y %H:%M:%S')
            print('rta_nuevo_msj["Estado"]', rta_nuevo_msj['Estado'])
            if rta_nuevo_msj['Estado'] is False:
                actualizar_fecha_actual(elementos['mensaje'],
                                        elementos['numero'])


largo_maximo_texto = 222


# numero o nombre y estado.
def crear_db_local(numero, estado, mensaje, fecha):
    """
    Esta funcion guarda en una 'basededatos.json' en json los mensajes
    nuevos.

    :param numero:(str)
    :param estado:(str)
    :param mensaje:(str)
    :param fecha:(str)
    :param ubicacion:(str)
    :return:
    """
    global verificar_pendientes

    # print(numero, estado, mensaje, fecha)
    fecha_hora_actual = datetime.now()
    datetime_to_str = fecha_hora_actual.strftime('%Y-%m-%d %H:%M:%S')

    try:
        numero = numero

        contador = 0

        # mensajes_utf8 = mensaje.encode('utf-8')

        global muylargo
        #             # print "envio normal"
        if mensaje == '':
            # print('mensaje vacio', mensaje)
            return

        # mensaje.encode('utf8')

        if len(mensaje) > largo_maximo_texto:

            mensaje = mensaje[:100]

            c.row_factory = sqlite3.Row
            query = c.execute("SELECT * FROM mensajes Where "
                              "muylargo=:muylargo and numero=:numero "
                              "and mensaje=:mensaje",
                              {'muylargo': '1', 'numero': numero,
                               'mensaje': mensaje})

            resultados = query.fetchall()

            print(resultados)
            if len(resultados) is 0:
                # if muylargo<1:
                #     muylargo == 1
                c.execute("INSERT INTO mensajes VALUES "
                          "('{}','{}','{}', '{}', '{}', '{}')".format(
                    fecha, mensaje,
                    estado, datetime_to_str, numero, muylargo))
                conn.commit()
                enviar_msg(numero, 'Su mensaje tiene mas de 250 caracteres,'
                                   ' no sera enviado al operador, porfavor,'
                                   ' acortelo, o dividalo en dos partes.')
                # return
        else:

            # acceder a los elementos con los nombres de los cambios de la tabla
            # en vez de usar los indices
            c.row_factory = sqlite3.Row
            query = c.execute("SELECT  * FROM mensajes Where "
                              "mensaje=:mensaje and numero=:numero and fecha_hora=:fecha_hora",
                              {'mensaje': mensaje, 'numero': numero,
                               'fecha_hora': fecha})

            resultados = query.fetchall()

            # rta = db.getmany(existe_mensaje)
            # por si ponen acentos o enies
            mensaje.encode('utf8')

            if len(resultados) is 0:
                print("la lista esta vacia")
                # tener cuidado con este metodo de insert ya que los datos se
                # guardan en la posicion que nosotros le indicamos.
                c.execute("INSERT INTO mensajes VALUES "
                          "('{}','{}','{}', '{}', '{}', '{}')".format(
                    fecha, mensaje.encode('utf8'), estado,
                    datetime_to_str, numero, 0))
                conn.commit()

                verificar_pendientes = False
                contador += 1
                # nuevo_msj_recibido(str(numero),
                #                    telefono_destino=TELEFONO_CLIENTE,
                #                    mensaje=mensaje, nombre='usuario',
                #                    hora_mensaje=fecha)
            if len(resultados) > 0:
                verificar_pendientes = True
                contador = 0

                reenviar_mjes_pendientes()
                verificar_pendientes = False

    except Exception as error:
        # muestra un error cuando se ingresa un mensaje unicode como enie
        # print("error crear_db_local", error)
        pass

    return contador


#######################################################

def marcar_mensaje_como_leido(numero, mensaje):
    """
    Marca los msgs como leidos
    :param nombre:
    :return:
    """
    try:
        # acceder a los elementos con los nombres de los cambios de la tabla
        # en vez de usar los indices
        c.row_factory = sqlite3.Row
        query = c.execute("SELECT  * FROM mensajes Where "
                          "mensaje=:mensaje and numero=:numero",
                          {'mensaje': mensaje, 'numero': numero})

        resultados = query.fetchall()

        # print("resultado", resultados)

        # si no encuentro resultado, no hago paso nada a pendiente.
        if resultados != "":
            # hago el update del mensaje y numeros recibidos.
            c.execute("UPDATE mensajes SET estado=='leido' "
                      "Where "
                      "mensaje=?"
                      "and numero=?",
                      (mensaje, numero))
            conn.commit()

    except Exception as error:
        print("Error en listar mensajes no leidos", error)

        dic = {}
        dic['Estado'] = False
        dic['Respuesta'] = "No se pudo pasar el estado de %s a pendiente." \
                           % numero
        return dic


#######################################################


def verificar_bateria():
    try:
        # busca si está la alerta de la batería
        elem = driver.find_element_by_xpath(
            "//span[@data-icon='alert-battery']")
    except:
        return


#######################################################


def tareas():
    """
    Esta funcion llama a las demás funciones
    Si 'estado_sesion' esta en false, es decir, si la sesion no esta iniciada
    no va a ejecutar ninguna de las funciones de abajo.
    """
    global estado_sesion
    # == True

    if estado_sesion:
        # esta funcion se encarga de verificar si un usuario seleccionado envio nuevos
        verificar_ventana_abierta()

        # llama al servidor para obtener los mensjaes para enviar
        obtener_msj_para_enviar(TELEFONO_CLIENTE)
        # reenviar_mensajes_pendientes()

        # verifica el  estado de la bateria
        verificar_bateria()
        listar_mensajes_no_leidos()
        # verificia_msjs_leidos_para_limpiar()
        # str_to_datetime = datetime.strptime(fecha_hora_actual, '%Y-%m-%d %H:%M:%S')
        # ult_envio < str_to_datetime - timedelta(seconds=15)
        # print ult_envio < str_to_datetime - timedelta(seconds=15)


# sin esto, la app no funciona. tiene que poner -phone nro_registrado
iniciar_app_con_parametro()

# this task verified that the session of wsp has open
# ejecutar_tarea(listar_mensajes_no_leidos(), (), 4)
# listar_mensajes_no_leidos()
# check messages slopes (pendientes)
# ejecutar_tarea(crear_db(), (), 5)

# Dejo el servidor levantado para que siempre ejecute las tareas
while True:
    time.sleep(1)
    # listar_mensajes_no_leidos()
    # reenviar_mensajes_pendientes()
    conectar()
    # crear_db_local('+54 9 3413 19-9175', 'ola vv', 'nuevo',
    #                '2020-08-09 15:42:56')
    # verificar_ventana_abierta()
    # revisar_mensajes_pendientes()
    func_no_bloquear(revisar_mensajes_pendientes())
    verificar_estado_de_la_sesion()
    func_no_bloquear(tareas())
